<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly
function social_sentiment_arraySort(&$arr, $col, $dir = SORT_DESC) {
    $sort_col = array();
    foreach ($arr as $key=> $row) {
        $sort_col[$key] = $row[$col];
    }

    array_multisort($sort_col, $dir, $arr);
}

function social_sentiment_trimFile($file, $lines){
	//trims file leaving last $lines lines
	if(!is_file($file)){
		//no log file so create one	
		$log = fopen($file, "w");
		fclose($log);
	}
	$linecount = 0;
	$handle = fopen($file, "r");
	while(!feof($handle)){
	  $line = fgets($handle);
	  $linecount++;
	}
	fclose($handle);
	//echo $linecount;
	if($linecount > $lines){
		$offset = $linecount - $lines;
		//echo "<br>offset: ".$offset;
		$handle = fopen($file, "r");
		$newFile = __DIR__."/tempFile";
		$handle2 = fopen($newFile, "w");
		$linecount2 = 0;
		while(!feof($handle)){
		  $line = fgets($handle);
		  if($linecount2 > $offset){
			  fwrite($handle2, $line);
		  }
		  $linecount2++;
		}
		unlink($file);
		rename($newFile, $file);
	}
	
}


function social_sentiment_logoutUser($loggedOut){
	$_SESSION = array();
	if (ini_get("session.use_cookies")) {
		$params = session_get_cookie_params();
		setcookie(session_name(), '', time() - 42000,
			$params["path"], $params["domain"],
			$params["secure"], $params["httponly"]
		);
	}
	
	// Finally, destroy the session.
	session_destroy();
	header("Location: ".$loggedOut);
    exit;
}
function social_sentiment_clearFiles($dir){
	$names = getDirectoryList($dir); // get all file names
	$status = true;
	foreach($names as $name){ // iterate files
	$file = $dir ."/". $name;
		if(file_exists($file) && !stringBeginsWith($file,".")){
		//echo $file . "<br>";
			if(!unlink($file)){
				$status = false;
			}
		}
	}
	return $status;
}

function social_sentiment_clearOldFiles($dir,$days,$string){
	//delete any files from dir path $dir older than $days days where name contains $string
	$com = "find '".$dir."/'*".$string."*.* -mtime +".$days." -exec rm {} \;";
	//$com = "find '".$dir."'/*".$string."*.* -mmin +".$days." -exec rm {} \;";//minutes
	exec($com);
}

function social_sentiment_getDirectoryList ($directory, $type=null) 
  {
    // create an array to hold directory list
    $results = array();

    // create a handler for the directory
	if(is_dir($directory)){
		$handler = opendir($directory);

		// open directory and walk through the filenames
		while ($file = readdir($handler)) {
	
		  // if file isn't this directory or its parent, add it to the results
		  if(!$type){
		  	if (!stringBeginsWith($file,".")) {
				$results[] = $file;
		  	}
		  }else
		  {
			if (!stringBeginsWith($file,".") && strpos($file,".".$type) !== false) {
				$results[] = $file;
		  	}
		  }
	
		}

		// tidy up: close the handler
		closedir($handler);
	}
	//make sure files are in order
	sort($results);
    // done!
    return $results;

}
function social_sentiment_getDirectoryListNoThumbs($directory) 
  {
    $results = array();
	if(is_dir($directory)){
		$handler = opendir($directory);
		while ($file = readdir($handler)) {
		  // if file isn't this directory or its parent, add it to the results
		  if (!stringBeginsWith($file,".") && !stringBeginsWith($file,"thumb")) {
			$results[] = $file;
		  }
		}
		closedir($handler);
	}
	//make sure files are in order
	sort($results);
    return $results;
}
//
function social_sentiment_getSubDirectories($dir){
	//return all sub directories containing and index file
	$validSubs = [];
	$subs = getDirectoryList($dir);
	foreach($subs as $sub){
		//
		if(is_dir($dir."/".$sub)){
			//echo $dir."/".$sub."<br>";
			if(is_file($dir."/".$sub."/index.php") || is_file($dir."/".$sub."/index.html")){
				$validSubs[] = $dir."/".$sub;

			}				
			$subSubs = getSubDirectories($dir."/".$sub);
			foreach($subSubs as $subSub){
				$validSubs[] = $subSub;
			}
		}
		
	}
	return $validSubs;
}
function social_sentiment_stringBeginsWith($string, $search){
  return (strncmp($string, $search, strlen($search)) == 0);
}
function social_sentiment_delete($file){
			if(file_exists($file)){
			//echo "here";
		  unlink($file);	
		}
}
function social_sentiment_deleteDir($dir){
	if(strstr($dir, "uploads")){
		$com = "rm -Rf ".$dir;
		exec($com);
	}
}
function social_sentiment_dirEmpty($dir){
	$q = (count(glob("$dir/*")) === 0) ? 'Empty' : 'Not empty';
    if ($q="Empty")
    {
        return true; 

    }else{

        return false;
    }
}
function social_sentiment_writeToLog($message){
	$logFile = $_SERVER['DOCUMENT_ROOT']."/log.txt";
	//echo $logFile;
		if(!is_file($logFile)){
			//create log file
			if($handle = fopen($logFile, 'w')){
			fclose($handle);
			}else
			{
				//echo "can't create log file !";
				return false;
			}
		}
	$log = fopen($logFile,'a');
	fwrite($log, timestampToDate(time())." - ".$message."\n");
	fclose($log);
	//return true;
}
//
function social_sentiment_readFileByLine($file,$dir){
	if(!is_file($file)){
		return "No log file";	
	}
	$handle = fopen($file, "r");
	$lines = "";
	if ($handle) {
		if($dir == "up"){
			while (($line = fgets($handle)) !== false) {
				$lines = $lines . '<br>' . $line;
			}
		}else
		{
			while (($line = fgets($handle)) !== false) {
				$lines = $line . '<br>' . $lines;
			}
		}
		fclose($handle);
	}
	return $lines;
}

function social_sentiment_postAsync($url, $params){
		foreach ($params as $key => &$val) {
		  if (is_array($val)) $val = implode(',', $val);
			$post_params[] = $key.'='.urlencode($val);
		}
		$post_string = implode('&', $post_params);
	
		$parts=parse_url($url);
	
		$fp = fsockopen($parts['host'],
			isset($parts['port'])?$parts['port']:80,
			$errno, $errstr, 30);
	
		$out = "POST ".$parts['path']." HTTP/1.1\r\n";
		$out.= "Host: ".$parts['host']."\r\n";
		$out.= "Content-Type: application/x-www-form-urlencoded\r\n";
		$out.= "Content-Length: ".strlen($post_string)."\r\n";
		$out.= "Connection: Close\r\n\r\n";
		if (isset($post_string)) $out.= $post_string;
	
		fwrite($fp, $out);
		fclose($fp);
}
//
function social_sentiment_httpPost($url,$params)
{
  $postData = '';
   //create name value pairs seperated by &
   foreach($params as $k => $v) 
   { 
      $postData .= $k . '='.$v.'&'; 
   }
   rtrim($postData, '&');
 
    $ch = curl_init();  
 
    curl_setopt($ch,CURLOPT_URL,$url);
    curl_setopt($ch,CURLOPT_RETURNTRANSFER,true);
    curl_setopt($ch,CURLOPT_HEADER, false); 
    curl_setopt($ch, CURLOPT_POST, count($postData));
    curl_setopt($ch, CURLOPT_POSTFIELDS, $postData);    
 	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    $output=curl_exec($ch);
 	//var_dump($output);
    curl_close($ch);
    return $output;
 
}
//
function social_sentiment_strip($val){
	$part1=str_replace('*','',$val);
	$part2=str_replace(',','',$part1);
	$part3=str_replace(' ','_',$part2);
	$part4=str_replace('&','',$part3);
	return $part4;
}
//
function social_sentiment_timestampToDate($timestamp, $format = 'H:i M d Y')
{
    return date($format, $timestamp);
}
//

function social_sentiment_readFileToString($file,$numbersOnly,$group) 
{
	//	[0-9]+ - Matches one or more numbers
	//[0-9]{8} - Matches exactly 8 numbers.
	//[0-9]{8,10} - Matches between 8 and 10 numbers.
	//[0-9]* - Matches zero or more numbers.
	//[0-9]? - Matches zero or one number.
	$file_handle = fopen($file, "rb");
	$line = "";
	$items = array();
	while (!feof($file_handle)) {
		$line = fgets($file_handle);
		if($numbersOnly == "yes"){
			if(preg_match_all("/[0-9]+/",$line,$matches)){
				foreach($matches[0] as $match){
					if($group != ""){
						if(strlen($match) == $group){
							$items[] = $match;
						}
					}else
					{
						$items[] = $match;
					}
				}
			}
		}else
		{
			//don't return empty lines
			if(preg_match("/[a-z]+|[0-9]+/i",$line)){
				$items[] = $line;
			}
		}
	}
	fclose($file_handle);
	return $items;
}
function social_sentiment_displayArray($array){
	//displays array of arrays
	$keys = array_keys($array[0]);
	echo '<div class="array_table">';
	//column headers
		echo '<div class="row">';
			foreach($keys as $key){
				echo '<span class="cellTitle">'.$key.'</span>';
			}
		echo '</div>';
		//data rows	
		foreach($array as $row){
			echo '<div class="row">';
				foreach($row as $data){
					echo '<span class="cell1">'.$data.'</span>';
				}
			echo '</div>';
		}
	echo '</div>';
}
function social_sentiment_fileCheck($maxSize,$allowed){
	//max size in Mb
	$message="OK";
	if($_FILES['file']['name'] != ""){
		
		
		//echo "filename: " . $_FILES['file'][name];
		if(strstr($allowed,'jpg')){
			$allowed .= ',jpeg';	
		}
		$parts = explode("/",$_FILES['file']['type']);
		$type = $parts[1];
		if(strstr($type,'-')){
			$parts = explode("-",$type);
			$num = count($parts);
			$type = $parts[$num-1];
		}
		if (stristr($allowed, $type))
		{
			//image file
			if(($_FILES['file']['size'] < 1000000*$maxSize)){
				if ($_FILES['file']['error'] > 0)
			   {
				   $message = "Please make sure your file is less than ".$maxSize."Mb";
				   return $message;
			   }else
			   {
				   return $message;	  
			   }
			}else
			{
				$message = "Please make sure your file is less than ".$maxSize."Mb";
			   return $message;
			}
		}else
		{
			$message = "You can only upload ".$allowed." files (not ".$type.")";
			return $message;
		}	
		
	}
}

function social_sentiment_processUpload($dir,$maxSize=10,$allowed='png,pdf,tiff,jpg,jpeg'){
	//$dir must be the absolute path
	$message = fileCheck($maxSize, $allowed);
	if ($message == "OK")
	{
		$file=$_FILES['file'];//array containing file attributes
		$fileName = $file['name'];//original name on local disc
		$tmpFile = $file['tmp_name'];
		$relative = rand().strip(basename($fileName));
		$target_path = $dir . "/" . $relative;
		try{
		move_uploaded_file($tmpFile, $target_path);
			//echo "The file ".  basename($fileName). " has been uploaded";
		} 
		catch(Exception $e){
			echo $e;
		}
		return $relative;

	}//end of if(filecheck()
	else
	{
		 //invalid image file
		 echo '<script language="javascript">';
		 echo 'alert("'.$message.'");';
		 echo '</script>';
		 return false;
	}
}

function social_sentiment_processVideoUpload($dir,$maxSize=50,$allowed='wmv,mpg,mp4,mov'){
	//$dir must be the absolute path
	$message = fileCheck($maxSize, $allowed);
	if ($message == "OK")
	{
		$file=$_FILES['file'];//array containing file attributes
		$fileName = $file['name'];//original name on local disc
		$tmpFile = $file['tmp_name'];
		$relative = rand().strip(basename($fileName));
		$target_path = $dir . "/" . $relative;
		try{
		move_uploaded_file($tmpFile, $target_path);
			//echo "The file ".  basename($fileName). " has been uploaded";
		} 
		catch(Exception $e){
			echo $e;
		}
		return $relative;

	}//end of if(filecheck()
	else
	{
		 //invalid image file
		 echo '<script language="javascript">';
		 echo 'alert("'.$message.'");';
		 echo '</script>';
		 return false;
	}
}

function social_sentiment_saveStats(){
	global $mysqli;
	$page = $_SERVER["REQUEST_URI"];
	$ip = getClientIP();
	$device = getDevice();
	$languageArray = getLanguage();
	$language = $languageArray[1];
	$ua=getBrowser();
	$browserName = $ua['name'];
	$browserVersion = $ua['version'];
	$browser = $browserName." ".$browserVersion;
	$platform = $ua['platform'];
	$format = 'd M Y';
	$stamp = time();
    $date = date($format, $stamp);
	writeToLog("Page ".$page." loaded");
	if(!$res = $mysqli->query("INSERT into visitors (date,page,ip,device,language,browser,platform,timestamp) VALUES('$date','$page','$ip','$device','$language','$browser','$platform',$stamp) ")){
			writeToLog("mysqli failed to write visitor record to database: ".mysqli_error());			
			echo "failed";
	}
}

function social_sentiment_getLanguage() 
{
	$l = array();
	$l[0] = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
	$file_handle = fopen("/web/new/data/language.csv", "rb");
	$done = false;
	while (!feof($file_handle) && !$done) {
		$line = fgets($file_handle);
		//echo $line."<br>";
		$parts = explode(',', $line);
		foreach($parts as $part){
			//echo $part."<br>";
			if($part == $l[0]){
			//found the line
			//echo $part;
			$l[1] = $parts[1];//language in english
			$l[2] = $parts[2];//language in native
			$done = true;
			}
		}
	}
	fclose($file_handle);
	return $l;
}

function social_sentiment_getDevice(){
	$useragent=$_SERVER['HTTP_USER_AGENT'];
	$kind = "desktop";
	if(preg_match('/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i',$useragent)||preg_match('/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i',substr($useragent,0,4)))
	{
		$kind = "mobile";
	}
	if(preg_match('/pad|hudl|nexus|kindle|tablet|slate|memo|venue|lumia|encore|transformer|miix|surface|tap/i',$useragent))
	{
		$kind = "tablet";
	}
	return $kind;
}
function social_sentiment_getBrowser() 
{ 
    $u_agent = $_SERVER['HTTP_USER_AGENT'];
	//echo $u_agent; 
    $bname = 'Unknown';
    $platform = 'Unknown';
    $version= "";

    //First get the platform?
    if (preg_match('/linux/i', $u_agent)) {
        $platform = 'linux';
    }
    if (preg_match('/macintosh|mac os x/i', $u_agent)) {
        $platform = 'Mac';
    }
    if (preg_match('/windows|win32/i', $u_agent)) {
        $platform = 'Windows';
    }    
	if (preg_match('/android/i', $u_agent)) {
        $platform = 'android';
    }
    
    // Next get the name of the useragent, yes seperately and for good reason  
	if(preg_match('/Safari/i',$u_agent)) 
    { 
        $bname = 'Apple Safari'; 
        $ub = "Safari"; 
    }
    if(preg_match('/MSIE|trident/i',$u_agent)  && !preg_match('/Opera/i',$u_agent)) 
    { 
        $bname = 'Internet Explorer'; 
        $ub = "MSIE"; 
    } 
    if(preg_match('/Firefox/i',$u_agent)) 
    { 
        $bname = 'Mozilla Firefox'; 
        $ub = "Firefox"; 
    } 
    if(preg_match('/Chrome/i',$u_agent)) 
    { 
        $bname = 'Google Chrome'; 
        $ub = "Chrome"; 
    } 
   
    if(preg_match('/Opera/i',$u_agent)) 
    { 
        $bname = 'Opera'; 
        $ub = "Opera"; 
    } 
    if(preg_match('/Netscape/i',$u_agent)) 
    { 
        $bname = 'Netscape'; 
        $ub = "Netscape"; 
    } 
	 if(preg_match('/dolphin/i',$u_agent)) 
    { 
        $bname = 'Dolphin'; 
        $ub = "Dolphin"; 
    }
	    if(preg_match('/maxthon/i',$u_agent)) 
    { 
        $bname = 'Maxthon'; 
        $ub = "Maxthon"; 
    }
    
    // finally get the correct version number
    $known = array('Version', $ub, 'other');
    $pattern = '#(?<browser>' . join('|', $known) .
    ')[/ ]+(?<version>[0-9.|a-zA-Z.]*)#';
    if (!preg_match_all($pattern, $u_agent, $matches)) {
        // we have no matching number just continue
    }
    
    // see how many we have
    $i = count($matches['browser']);
    if ($i != 1) {
        //we will have two since we are not using 'other' argument yet
        //see if version is before or after the name
        if (strripos($u_agent,"Version") < strripos($u_agent,$ub)){
            $version= $matches['version'][0];
        }
        else {
            $version= $matches['version'][1];
        }
    }
    else {
        $version= $matches['version'][0];
    }
    
    // check if we have a number
    if ($version==null || $version=="") {$version="?";}
    
    return array(
        'userAgent' => $u_agent,
        'name'      => $bname,
        'version'   => $version,
        'platform'  => $platform,
        'pattern'    => $pattern
    );
} 
function social_sentiment_social_sentiment_getClientIP( )
{
    //if (getenv('HTTP_X_FORWARDED_FOR'))
    {
        //return getenv('HTTP_X_FORWARDED_FOR');
    }
    return getenv('REMOTE_ADDR');
}
//
function social_sentiment_generateCode($length = 16) {
    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
    $charactersLength = strlen($characters);
    $randomString = '';
    for ($i = 0; $i < $length; $i++) {
        $randomString .= $characters[rand(0, $charactersLength - 1)];
    }
    return $randomString;
}
?>